// XpaDemoInCallDlg.cpp : implementation file
//

#include "stdafx.h"
#include "XpaDemo.h"

#include "XpipeAPI.h"					// XpipeAPI stuff

#include "XpaDemoInCallDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CXpaDemoInCallDlg dialog


CXpaDemoInCallDlg::CXpaDemoInCallDlg(int Lcn, XPA_MSG_DATA *pCallData, CWnd* pParent /*=NULL*/)
	: CDialog(CXpaDemoInCallDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CXpaDemoInCallDlg)
	m_accCallData = _T("");
	m_accDbit = FALSE;
	m_clearCause = 0;
	m_clearData = _T("");
	m_clearDiag = 0;
	m_inCallData = _T("");
	m_inDbit = _T("");
	m_inLcn = _T("");
	//}}AFX_DATA_INIT

	// remember the logical channel number ...
	m_Lcn = Lcn;

	// 
	// set up input dialog variables ...
	//

	// logical channel number
	m_inLcn.Format("%d", m_Lcn);
	// D-bit 
	m_inDbit = (pCallData->Q_D_M_bits) ? "set" : "reset";
	// call data
	if (pCallData->buffer_length) {
		m_inCallData.Format("%s", pCallData->data);
	}

	// notify API that we've processed WMXPA_ASY_INCALL message so it can 
	// free the message data
	xpaMsgComplete( pCallData );

	// display the dialog ...
	Create(IDD_XPADEMO_INCALL_DIALOG, pParent);
}


void CXpaDemoInCallDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CXpaDemoInCallDlg)
	DDX_Text(pDX, IDC_ACCCALLDATA, m_accCallData);
	DDV_MaxChars(pDX, m_accCallData, 1027);
	DDX_Check(pDX, IDC_ACCDBIT, m_accDbit);
	DDX_Text(pDX, IDC_CLEARCAUSE, m_clearCause);
	DDX_Text(pDX, IDC_CLEARDATA, m_clearData);
	DDV_MaxChars(pDX, m_clearData, 1027);
	DDX_Text(pDX, IDC_CLEARDIAG, m_clearDiag);
	DDX_Text(pDX, IDC_INCALLDATA, m_inCallData);
	DDX_Text(pDX, IDC_INDBIT, m_inDbit);
	DDX_Text(pDX, IDC_LCN, m_inLcn);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CXpaDemoInCallDlg, CDialog)
	//{{AFX_MSG_MAP(CXpaDemoInCallDlg)
	ON_BN_CLICKED(IDC_ACCEPT, OnAcceptClicked)
	ON_BN_CLICKED(IDC_CLEAR, OnClearClicked)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXpaDemoInCallDlg message handlers

//
// "Accept Call" button clicked
//
void CXpaDemoInCallDlg::OnAcceptClicked() 
{
	int		iRVal;							// return value from the call
	BYTE QDMbits = 0x00;

	UpdateData( TRUE );						// read in dialog data

	if (m_accDbit) QDMbits |= 0x02;//0x01 - M bit, 0x02 - D bit, 0x04 - Q bit

	if (0 != (iRVal=xpaAcceptCall( 1, m_Lcn, (char*)(LPCTSTR)m_accCallData, QDMbits ))) {
		// failure ...
		char	szMsgString[MAX_PATH];
		sprintf( szMsgString, "Failed to accept call. Return value 0x%02X, last error %d", iRVal, xpaGetLastError());
		MessageBox( szMsgString );
	}
	// destroy the dialog box
	DestroyWindow();
	
	// since we created the dialog on heap - we need to delete it as well
	delete this;
}

//
// "Clear Call" button clicked
//
void CXpaDemoInCallDlg::OnClearClicked() 
{
	int		iRVal;							// return value from the call

	UpdateData( TRUE );						// read in dialog data

	if (0 != (iRVal=xpaClearCall( 1, m_Lcn, (char*)(LPCTSTR)m_clearData, TRUE, m_clearCause, m_clearDiag ))) {
		// failure ...
		char	szMsgString[MAX_PATH];
		sprintf( szMsgString, "Failed to clear call. Return value 0x%02X, last error %d", iRVal, xpaGetLastError());
		MessageBox( szMsgString );
	}
	// destroy the dialog box
	DestroyWindow();

	// since we created the dialog on heap - we need to delete it as well
	delete this;
}
